Subject: Re: bug#13378: [IMPORTANT] Make the 'subdir-objects' setup the default, and only available one

From: Nick Bowler <[email-masked]>
Date: Tue, 8 Jan 2013 09:53:20 -0500

On 2013-01-08 13:17 +0100, Stefano Lattarini wrote:
> Actually, the warning about a missing AM_PROG_CC_C_O will be automatically
> given once the user has added 'subdir-objects' to the AUTOMAKE_OPTIONS.
> 
>   - the user sees the warning about missing 'subdir-objects' option;
>   - he adds it to AM_INIT_AUTOMAKE, and calls "autoreconf";
>   - he now sees the warning about AM_PROG_CC_C_O that is now triggered
>     by the presence of 'subdir-objects';
>   - he add AM_PROG_CC_C_O to configure.ac, and calls autoreconf.
> 
> However, I see that it would be nice to try to be smarter and give
> the warning right away, to save the user that potentially annoy
> second bootstrap.  So I still think your suggestion is a good idea.

I don't think AM_PROG_CC_C_O is optional at all when subdir-objects is
enabled.  Even with a single source file in a the same directory as the
Makefile, Automake is generating a suffix rule that looks like this:

  .c.o:
  [...]
  @am__fastdepCC_FALSE@	$(COMPILE) -c -o $@ $<

which looks like it's using -c and -o together to me.  So if
subdir-objects is made mandatory, AM_PROG_CC_C_O will become mandatory
as well, so AM_INIT_AUTOMAKE may as well just call it automatically.

Cheers,
-- 
Nick Bowler, Elliptic Technologies (http://www.elliptictech.com/)